#!/usr/bin/python3

from math import gcd
import sys

height, width = [int(x) for x in input().split()]
g = gcd(height, width)
bitmap = {"w" : 1, "r" : 2, "b" : 4, "g" : 8}
grid = [[bitmap[x] for x in input()] for _ in range(height)]

all_available = set()

for w1 in range(width):
    for w2 in range(w1 + 1, width):
        present = [[False for _ in range(16)] for _ in range(g)]
        for h in range(height):
            if grid[h][w1] != grid[h][w2]:
                present[h % g][grid[h][w1] + grid[h][w2]] = True
        if any(present[h][l] and present[(h + w2 - w1) % g][15 - l] for l in range(16) for h in range(g)):
            print("possible")
            sys.exit(0)

print("impossible")

