fun main() {
    val (n, m) = readln().split(" ").map { it.toInt() }
    // Create a frequency table for each city name
    val frequencies = Array(m) { IntArray(26) }
    System.`in`.bufferedReader().lineSequence().take(n).forEach { line ->
        line.forEachIndexed { index, c -> frequencies[index][c - 'a'] += 1 }
    }
    // Build the country name
    frequencies.joinToString(separator = "") {
        var best = 0
        var bestFrequency = 0
        it.indices.forEach { i ->
            if (it[i] > bestFrequency) {
                best = i
                bestFrequency = it[i]
            }
        }
        "${'a' + best}"
    }.also { println(it) }
}
