#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int64_t n, c;
vector<int64_t> a;

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> c;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int64_t ans = n+1;
    int64_t ansI = -1;
    for (int i = 0; i < n; ++i) {
        int64_t currentQueue = 0;
        for (int j = 0; j < i; ++j) {
            currentQueue = max(static_cast<int64_t>(0), currentQueue + a[j] - c);
        }
        currentQueue += a[i];
        int64_t currentWait = (currentQueue + 1 + (c - 1)) / c;
        if (i + currentWait > n) {
            break;
        }
        if (currentWait < ans) {
            ans = currentWait;
            ansI = i;
        }
        if (currentWait == 0) {
            break;
        }
    }

    if (ans > n) {
        cout << "impossible" << endl; 
    } else {
        cout << ansI << endl;
    }
    return 0;
}
