#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int64_t n, c;
vector<int64_t> a;

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> c;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int64_t currentQueue = 0;
    int64_t ans = n+1;
    int64_t ansI = -1;
    for (int i = 0; i < n; ++i) {
        currentQueue += a[i];
        int64_t currentWait = (currentQueue + 1) / c;
        if (currentWait < ans && i + currentWait < n) {
            ans = currentWait;
            ansI = i;
        }
        currentQueue = max(static_cast<int64_t>(0), currentQueue - c);
    }

    if (ans > n) {
        cout << "impossible" << endl; 
    } else {
        cout << ansI << endl;
    }
    return 0;
}
