#!/usr/bin/env python3
pairs = lambda a : [(x,y) for c,x in enumerate(a) for y in a[:c]]
points = [[int(i) for i in input().split()] for i in range(4)]
vectors = [[y[0]-x[0],y[1]-x[1]] for x,y in pairs(points)]
inp = lambda x,y : x[0]*y[0] + x[1]*y[1]
perp = lambda x,y : inp(x,y) == 0
rot = lambda x : [x[1],-x[0]]
parallel = sum([perp(a,rot(b)) for a,b in pairs(vectors)])
angles = sum([perp(a,b) for a,b in pairs(vectors)])
shapes = ["none","trapezium","parallelogram","rhombus","parallelogram","impossible","rectangle","square"]
print(shapes[parallel + (angles if parallel == 2 else 0)])
# TODO: add "kite"
