#!/usr/bin/env python3
points = [[int(i) for i in input().split()] for i in range(4)]
vectors = [[points[i][0]-points[i-1][0], points[i][1]-points[i-1][1]] for i in range(4)]
inp = lambda x,y : x[0]*y[0] + x[1]*y[1]
perp = lambda x,y : inp(x,y) == 0
rot = lambda x : [x[1],-x[0]]
parallel = perp(vectors[0],rot(vectors[2])) + perp(vectors[1],rot(vectors[3]))
if parallel == 0: print("none")
elif parallel == 1: print("trapezium")
else:
    right_angle = perp(vectors[0],vectors[1])
    length = inp(vectors[0],vectors[0]) == inp(vectors[1],vectors[1])
    print(["parallelogram","rhombus","rectangle","square"][2*right_angle+length])
# TODO: add "kite"
