class Directory(var tot: Int, val children : MutableMap<String, Directory>)
fun main() {
    val root = Directory(0, mutableMapOf())
    var ans = 0
    val n = readln().toInt()
    repeat(n) {
        val s = readln().drop(1).split("/")
        ans += s.size
        var cur = root
        for (part in s) {
            cur = cur.children.getOrPut(part) { Directory(0, mutableMapOf())}
            cur.tot++
        }
    }
    var cur = root
    while (true) {
        cur = cur.children.values.maxByOrNull { it.tot }?.takeIf { 2 * it.tot > n } ?: break
        ans -= 2 * cur.tot - n
    }
    println(ans)
}
