import java.util.Scanner;

public class NickyEnMark {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);

		int n = scanner.nextInt();
		int m = scanner.nextInt();

		int[][] counts = new int[m][];
		for (int i = 0; i < m; i++) {
			counts[i] = new int[26];
		}

		for (int i = 0; i < n; i++) {
			char[] letters = scanner.next().toCharArray();
			for (int j = 0; j < m; j++) {
				counts[j][letters[j] - 'a']++;
			}
		}

		for (int j = 0; j < m; j++) {
			int max = -1;
			char maxChar = '_';
			for (int k = 0; k < 26; k++) {
				if (counts[j][k] > max) {
					max = counts[j][k];
					maxChar = (char) (k + 'a');
				}
			}

			System.out.print(maxChar);
		}

		System.out.println();
	}
}
