#!/usr/bin/env python3
n = int(input())
M = 10**9 + 7
cs = [[] for _ in range(n)]
for i in range(1, n):
    p = int(input())
    cs[p].append(i)


def merge(xs, ys):
    l = [0] * (len(xs) + len(ys) - 1)
    for i in range(len(xs)):
        for j in range(len(ys)):
            l[i + j] += xs[i] * ys[j]
            l[i + j] %= M
    return l


ans = [0] * (n + 1)


def dfs(u):
    us = [0, 1]
    for v in cs[u]:
        vs = dfs(v)
        assert vs[0] == 0
        vs[0] = 1
        us = merge(us, vs)
    for i in range(len(us)):
        ans[i] += us[i]
        ans[i] %= M
    return us


dfs(0)
for x in ans[1:]:
    print(x)
