#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
using namespace std;

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<int> s(n);
	for(auto& x : s) cin >> x;
	sort(s.rbegin(), s.rend());
	long long sum     = accumulate(s.begin(), s.end(), 0ll);
	long long largest = 0;
	for(int i = 0; i < min(m + k, n); ++i) {
		largest += s[i];
	}
	// NOTE: C++ by default prints 6 significant digits, which is sufficient.
	cout << 100.l * largest / sum << endl;
}
