#!/usr/bin/env python3
import math

C = {"w": 0, "r": 1, "g": 2, "b": 3}

h, w = map(int, input().split())
b = [[C[x] for x in input()] for _ in range(h)]
g = math.gcd(h, w)
for x in range(w):
    for y in range(w):
        r = (y - x) % w
        # Only consider pairs of rows (k%g and (k+r)%g).
        for k in range(g):
            agrid = [[False] * 4 for _ in range(4)]
            for i in range(k, h, g):
                agrid[b[i][x]][b[i][y]] = True
                agrid[b[i][y]][b[i][x]] = True
            bgrid = [[False] * 4 for _ in range(4)]
            for i in range((k + r) % g, h, g):
                bgrid[b[i][x]][b[i][y]] = True
                bgrid[b[i][y]][b[i][x]] = True
            if (
                (agrid[0][1] and bgrid[2][3])
                or (agrid[0][2] and bgrid[1][3])
                or (agrid[0][3] and bgrid[1][2])
                or (agrid[1][2] and bgrid[0][3])
                or (agrid[1][3] and bgrid[0][2])
                or (agrid[2][3] and bgrid[0][1])
            ):
                print("possible")
                exit()
print("impossible")
