#!/usr/bin/env python3
n = int(input())
ps = [input().split("/")[1:] for _ in range(n)]
ps.sort()
total_components = sum(len(p) for p in ps)
ans = total_components + 1


def cp(a, b):
    i = 0
    while i < len(a) and i < len(b) and a[i] == b[i]:
        i += 1
    return i


def test(idx):
    global ans
    p = ps[idx][:-1]
    counts = [0] * 1000000
    for q in ps:
        counts[cp(p, q)] += 1
    saved = 0
    remaining = n
    lost = 0
    for l in range(0, len(p) + 1):
        ans = min(ans, total_components - saved)
        remaining -= counts[l]
        lost += counts[l]
        if remaining <= lost:
            break
        saved += remaining - lost


test(n // 2)
if n % 2 == 0:
    test(n // 2 - 1)
print(ans)
