#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

template<class T> ostream& operator<<(ostream &os, vector<T> &v) {
    os << "\n[";
    for(T &x : v) os << x << ',';
    return os << "]\n";
}

struct pairhash {
    public:
    template<typename T1, typename T2>
    size_t operator()(const pair<T1, T2> &p) const {
        size_t lhs = hash<T1>()(p.x);
        size_t rhs = hash<T2>()(p.y);
        return lhs ^ (rhs+0x9e3779b9+(lhs<<6)+(lhs>>2));
    }
};

const ll INF = 1'000'000'000'000'000'000;

void run() {
	ll n;
	cin >> n;
	vvi A(n+1, vi(n+1, -INF));
	A[0][0] = 0;
	ll t = 0;
	for (ll i = 0; i < n; i++) {
		ll s, p, e, a;
		cin >> s >> p >> e >> a;
		for (ll j = 0; j <= n; j++) {
			A[i+1][j] = A[i][j] + s-t;
			if (j > 0 && a <= A[i][j-1]+s-t) {
				A[i+1][j] = max(A[i+1][j], A[i][j-1]+s-t - a + e-p);
			}
		}
		t = e;
	}
	for (ll i = n; i >= 0; i--) {
		if (A[n][i] >= 0) {
			cout << i << endl;
			break;
		}
	}
}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
