#!/usr/bin/python3

from math import gcd

height, width = [int(x) for x in input().split()]
g = gcd(height, width)
bitmap = {"w" : 1, "r" : 2, "b" : 4, "g" : 8}
grid = [[bitmap[x] for x in input()] for _ in range(height)]

all_available = set()

for h in range(height):
    for w1 in range(width):
        for w2 in range(w1 + 1, width):
            all_available.add((h % g, w1, w2, grid[h][w1] + grid[h][w2]))

for h, w1, w2, l in all_available:
    if ((h + w2 - w1) % g, w1, w2, 15-l) in all_available:
        print("possible")
        break
else:
    print("impossible")

